* m32r/tm-m32r.h (TARGET_M32R): Define, for wingdb.
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash m4 autoconf ispell grep diff rcs cvs fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk findutils"
53
54
55 # these libraries are built for the target environment, and are built after
56 # the host libraries and the host tools (which may be a cross compiler)
57 #
58 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
59
60
61 # these tools are built using the target libs, and are intended to run only
62 # in the target environment
63 #
64 # note: any program that *uses* libraries that are in the "target_libs"
65 # list belongs in this list. those programs are also very likely
66 # candidates for the "native_only" list which follows
67 #
68 target_tools="target-examples target-groff"
69
70 ################################################################################
71
72 ## These two lists are of directories that are to be removed from the
73 ## ${configdirs} list for either cross-compilations or for native-
74 ## compilations. For example, it doesn't make that much sense to
75 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
76 ## a native environment.
77
78 # directories to be built in the native environment only
79 #
80 # This must be a single line because of the way it is searched by grep in
81 # the code below.
82 native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time bash prms"
83
84 # directories to be built in a cross environment only
85 #
86 cross_only="target-libiberty target-libgloss target-newlib"
87
88 ## All tools belong in one of the four categories, and are assigned above
89 ## We assign ${configdirs} this way to remove all embedded newlines. This
90 ## is important because configure will choke if they ever get through.
91 ## ${configdirs} is directories we build using the host tools.
92 ## ${target_configdirs} is directories we build using the target tools.
93 #
94 configdirs=`echo ${host_libs} ${host_tools}`
95 target_configdirs=`echo ${target_libs} ${target_tools}`
96
97 ################################################################################
98
99 srctrigger=move-if-change
100 srcname="gnu development package"
101
102 # This gets set non-empty for some net releases of packages.
103 appdirs=""
104
105 # per-host:
106
107 # Work in distributions that contain no compiler tools, like Autoconf.
108 if [ -d ${srcdir}/config ]; then
109 case "${host}" in
110 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
111 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
112 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
113 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
114 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
115 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
116 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
117 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
118 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
119 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
120 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
121 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
122 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
123 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
124 i[3456]86-*-dgux*) host_makefile_frag=config/mh-dgux386 ;;
125 i[3456]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
126 i[3456]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
127 i[3456]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
128 i[3456]86-*-sco*) host_makefile_frag=config/mh-sco ;;
129 i[3456]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
130 i[3456]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
131 i[3456]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
132 i[3456]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
133 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
134 *-windows*) host_makefile_frag=config/mh-windows ;;
135 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
136 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
137 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
138 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
139 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
140 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
141 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
142 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
143 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
144 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
145 esac
146 fi
147
148 # If we aren't going to be using gcc, see if we can extract a definition
149 # of CC from the fragment.
150 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
151 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
152 found=
153 for dir in $PATH; do
154 test -z "$dir" && dir=.
155 if test -f $dir/gcc; then
156 found=yes
157 break
158 fi
159 done
160 IFS="$save_ifs"
161 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
162 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
163 if [ -n "${xx}" ] ; then
164 CC=$xx
165 fi
166 fi
167 fi
168
169 # We default to --with-shared on platforms where -fpic is meaningless.
170 # Well, we don't yet, but we will.
171 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
172 case "${target}" in
173 alpha-dec-osf*) enable_shared=yes ;;
174 alpha-*-linux*) enable_shared=yes ;;
175 mips-sgi-irix5*) enable_shared=yes ;;
176 *) enable_shared=no ;;
177 esac
178 fi
179
180 case "${enable_shared}" in
181 yes) shared=yes ;;
182 no) shared=no ;;
183 "") shared=no ;;
184 *) shared=yes ;;
185 esac
186
187 if [ x${shared} = xyes ]; then
188 waugh=
189 case "${host}" in
190 hppa*) waugh=config/mh-papic ;;
191 i[3456]86-*) waugh=config/mh-x86pic ;;
192 sparc64-*) waugh=config/mh-sparcpic ;;
193 *) waugh=config/mh-${host_cpu}pic ;;
194 esac
195 if [ -f ${srcdir}/${waugh} ]; then
196 if [ -n "${host_makefile_frag}" ] ; then
197 cat ${srcdir}/${host_makefile_frag} > mh-frag
198 cat ${srcdir}/${waugh} >> mh-frag
199 host_makefile_frag=mh-frag
200 else
201 host_makefile_frag=${waugh}
202 fi
203 fi
204 fi
205
206 # per-target:
207
208 case "${target}" in
209 v810*) target_makefile_frag=config/mt-v810 ;;
210 i[3456]86-*-netware*) target_makefile_frag=config/mt-netware ;;
211 # start-sanitize-r5900
212 mips64vr5900*-*-*) target_makefile_frag=config/mt-r5900 ;;
213 # end-sanitize-r5900
214 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
215 esac
216
217 skipdirs=
218 gasdir=gas
219 use_gnu_ld=
220 use_gnu_as=
221
222 # some tools are so dependent upon X11 that if we're not building with X,
223 # it's not even worth trying to configure, much less build, that tool.
224
225 case ${with_x} in
226 yes | "") # the default value for this tree is that X11 is available
227 ;;
228 no)
229 skipdirs="${skipdirs} tk gash"
230 ;;
231 *)
232 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
233 ;;
234 esac
235
236 # Some tools are only suitable for building in a "native" situation.
237 # Those are added when we have a host==target configuration. For cross
238 # toolchains, we add some directories that should only be useful in a
239 # cross-compiler.
240
241 is_cross_compiler=
242
243 if [ x"${host}" = x"${target}" ] ; then
244 # when doing a native toolchain, don't build the targets
245 # that are in the 'cross only' list
246 skipdirs="${skipdirs} ${cross_only}"
247 is_cross_compiler=no
248 target_subdir=.
249 else
250 # similarly, don't build the targets in the 'native only'
251 # list when building a cross compiler
252 skipdirs="${skipdirs} ${native_only}"
253 is_cross_compiler=yes
254 target_subdir=${target_alias}
255 if [ ! -d ${target_subdir} ] ; then
256 if mkdir ${target_subdir} ; then true
257 else
258 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
259 exit 1
260 fi
261 fi
262 fi
263
264 copy_dirs=
265
266 # Handle --with-headers=XXX. The contents of the named directory are
267 # copied to $(tooldir)/sys-include.
268 if [ x"${with_headers}" != x ]; then
269 if [ x${is_cross_compiler} = xno ]; then
270 echo 1>&2 '***' --with-headers is only supported when cross compiling
271 exit 1
272 fi
273 case "${exec_prefixoption}" in
274 "") x=${prefix} ;;
275 *) x=${exec_prefix} ;;
276 esac
277 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
278 fi
279
280 # Handle --with-libs=XXX. Multiple directories are permitted. The
281 # contents are copied to $(tooldir)/lib.
282 if [ x"${with_libs}" != x ]; then
283 if [ x${is_cross_compiler} = xno ]; then
284 echo 1>&2 '***' --with-libs is only supported when cross compiling
285 exit 1
286 fi
287 # Copy the libraries in reverse order, so that files in the first named
288 # library override files in subsequent libraries.
289 case "${exec_prefixoption}" in
290 "") x=${prefix} ;;
291 *) x=${exec_prefix} ;;
292 esac
293 for l in ${with_libs}; do
294 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
295 done
296 fi
297
298 # If both --with-headers and --with-libs are specified, default to
299 # --without-newlib.
300 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
301 if [ x"${with_newlib}" = x ]; then
302 with_newlib=no
303 fi
304 fi
305
306 # Recognize --with-newlib/--without-newlib.
307 if [ x${with_newlib} = xno ]; then
308 skipdirs="${skipdirs} target-newlib"
309 elif [ x${with_newlib} = xyes ]; then
310 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
311 fi
312
313 # Default to using --with-stabs for certain targets.
314 if [ x${with_stabs} = x ]; then
315 case "${target}" in
316 mips*-*-irix6*)
317 ;;
318 mips*-*-* | alpha*-*-osf* | i[3456]86*-*-sysv4* | i[3456]86*-*-unixware*)
319 with_stabs=yes;
320 withoptions="${withoptions} --with-stabs"
321 ;;
322 esac
323 fi
324
325 # Handle ${copy_dirs}
326 set fnord ${copy_dirs}
327 shift
328 while [ $# != 0 ]; do
329 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
330 :
331 else
332 echo Copying $1 to $2
333
334 # Use the install script to create the directory and all required
335 # parent directories.
336 if [ -d $2 ]; then
337 :
338 else
339 echo >config.temp
340 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
341 fi
342
343 # Copy the directory, assuming we have tar.
344 # FIXME: Should we use B in the second tar? Not all systems support it.
345 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
346
347 # It is the responsibility of the user to correctly adjust all
348 # symlinks. If somebody can figure out how to handle them correctly
349 # here, feel free to add the code.
350
351 echo $1 > $2/COPIED
352 fi
353 shift; shift
354 done
355
356 # Configure extra directories which are host specific
357
358 case "${host}" in
359 i[3456]86-*-go32*)
360 configdirs="$configdirs dosrel" ;;
361 *-cygwin32*)
362 configdirs="$configdirs dosrel" ;;
363 esac
364
365 # Remove more programs from consideration, based on the host or
366 # target this usually means that a port of the program doesn't
367 # exist yet.
368
369 noconfigdirs=""
370
371 case "${host}" in
372 i[3456]86-*-vsta)
373 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
374 ;;
375 i[3456]86-*-go32)
376 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
377 ;;
378 *-*-cygwin32)
379 noconfigdirs="tk tcl expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet"
380 ;;
381 *-*-windows*)
382 # This is only used to build WinGDB...
383 configdirs="bfd gdb libiberty opcodes readline sim"
384 target_configdirs=
385 ;;
386 ppc*-*-pe)
387 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
388 ;;
389 esac
390
391
392 case "${target}" in
393 *-*-netware)
394 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
395 ;;
396 *-*-vxworks*)
397 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
398 ;;
399 alpha-dec-osf*)
400 # ld works, but does not support shared libraries. emacs doesn't
401 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
402 # gas doesn't generate exception information.
403 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
404 ;;
405 alpha*-*-*vms*)
406 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
407 ;;
408 alpha*-*-*)
409 # newlib is not 64 bit ready
410 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
411 ;;
412 # start-sanitize-arc
413 arc-*-*)
414 noconfigdirs="$noconfigdirs target-libgloss"
415 ;;
416 # end-sanitize-arc
417 arm-*-pe*)
418 noconfigdirs="$noconfigdirs target-libgloss"
419 ;;
420 arm-*-coff*)
421 noconfigdirs="$noconfigdirs target-libgloss"
422 ;;
423 arm-*-riscix*)
424 noconfigdirs="$noconfigdirs ld target-libgloss"
425 ;;
426 # start-sanitize-d10v
427 d10v-*-*)
428 noconfigdirs="$noconfigdirs target-librx target-libg++ target-libstdc++ target-libio target-libgloss"
429 ;;
430 # end-sanitize-d10v
431 h8300*-*-* | \
432 h8500-*-*)
433 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
434 ;;
435 hppa*-*-*elf* | \
436 hppa*-*-lites*)
437 # Do configure ld/binutils/gas for this case.
438 ;;
439 hppa*-*-*)
440 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
441 # cc is gcc, and on any system a user should be able to link cc to
442 # whatever they want. FIXME, emacs emacs19).
443 case "${CC}" in
444 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
445 *) ;;
446 esac
447 noconfigdirs="$noconfigdirs ld shellutils"
448 ;;
449 i[3456]86-*-go32)
450 # but don't build gdb
451 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
452 ;;
453 *-*-cygwin32)
454 target_configdirs="$target_configdirs target-winsup"
455 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
456 # always build newlib.
457 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
458
459 # Can't build gdb for cygwin32 if not native.
460 case "${host}" in
461 *-*-cygwin32) ;; # keep gdb
462 *) noconfigdirs="$noconfigdirs gdb"
463 esac
464 ;;
465 i[3456]86-*-pe)
466 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
467 ;;
468 i[3456]86-*-sco3.2v5*)
469 # The linker does not yet know about weak symbols in COFF,
470 # and is not configured to handle mixed ELF and COFF.
471 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
472 ;;
473 i[3456]86-*-sco*)
474 noconfigdirs="$noconfigdirs gprof target-libgloss"
475 ;;
476 i[3456]86-*-solaris2*)
477 # The linker does static linking correctly, but the Solaris C library
478 # has bugs such that some important functions won't work when statically
479 # linked. (See man pages for getpwuid, for example.)
480 noconfigdirs="$noconfigdirs ld target-libgloss"
481 ;;
482 i[3456]86-*-sysv4*)
483 # The SYSV4 C compiler doesn't handle Emacs correctly
484 case "${CC}" in
485 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
486 *) ;;
487 esac
488 # but that's okay since emacs doesn't work anyway
489 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
490 ;;
491 mn10200-*-*)
492 noconfigdirs="$noconfigdirs target-libgloss"
493 ;;
494 mn10300-*-*)
495 noconfigdirs="$noconfigdirs target-libgloss"
496 ;;
497 powerpc-*-aix*)
498 # copied from rs6000-*-* entry
499 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
500 # This is needed until gcc and ld are fixed to work together.
501 use_gnu_ld=no
502 ;;
503 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
504 target_configdirs="$target_configdirs target-winsup"
505 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
506 # always build newlib.
507 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
508 ;;
509 # This is temporary until we can link against shared libraries
510 powerpcle-*-solaris*)
511 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
512 ;;
513 rs6000-*-lynxos*)
514 # The CVS server code doesn't work on the RS/6000
515 # Newlib makes problems for libg++ in crosses.
516 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
517 ;;
518 rs6000-*-aix*)
519 noconfigdirs="$noconfigdirs gprof"
520 # This is needed until gcc and ld are fixed to work together.
521 use_gnu_ld=no
522 ;;
523 rs6000-*-*)
524 noconfigdirs="$noconfigdirs gprof"
525 ;;
526 m68k-apollo-*)
527 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
528 ;;
529 mips*-*-irix5*)
530 # The GNU linker does not support shared libraries.
531 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
532 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
533 ;;
534 mips*-*-irix6*)
535 # The GNU linker does not support shared libraries.
536 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
537 noconfigdirs="$noconfigdirs ld gas gprof emacs target-libgloss"
538 ;;
539 mips*-dec-bsd*)
540 noconfigdirs="$noconfigdirs gprof target-libgloss"
541 ;;
542 mips*-*-bsd*)
543 noconfigdirs="$noconfigdirs gprof target-libgloss"
544 ;;
545 mips*-*-*)
546 noconfigdirs="$noconfigdirs gprof"
547 ;;
548 romp-*-*)
549 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
550 ;;
551 sh-*-*)
552 case "${host}" in
553 i[3456]86-*-vsta) ;; # don't add gprof back in
554 i[3456]86-*-go32) ;; # don't add gprof back in
555 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
556 esac
557 noconfigdirs="$noconfigdirs target-libgloss"
558 ;;
559 sparc-*-sunos4*)
560 if [ x${is_cross_compiler} != xno ] ; then
561 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
562 else
563 use_gnu_ld=no
564 fi
565 ;;
566 # start-sanitize-tic80
567 tic80-*-*)
568 noconfigdirs="$noconfigdirs gcc gdb ld target-libio target-libg++ target-libstdc++ target-libgloss"
569 ;;
570 # end-sanitize-tic80
571 v810-*-*)
572 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
573 ;;
574 # start-sanitize-v850
575 v850-*-*)
576 noconfigdirs="$noconfigdirs target-libgloss"
577 ;;
578 # end-sanitize-v850
579 vax-*-vms)
580 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
581 ;;
582 vax-*-*)
583 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
584 ;;
585 *-*-lynxos*)
586 # Newlib makes problems for libg++ in crosses.
587 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
588 ;;
589 *-*-macos* | \
590 *-*-mpw*)
591 # Macs want a resource compiler.
592 configdirs="$configdirs grez"
593 ;;
594 esac
595
596 # targets that need a second pass
597 case "${target}" in
598 *-gm-magic*)
599 noconfigdirs="$noconfigdirs target-libgloss"
600 ;;
601 esac
602
603 # If we aren't building newlib, then don't build libgloss, since libgloss
604 # depends upon some newlib header files.
605 case "${noconfigdirs}" in
606 *target-libgloss*) ;;
607 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
608 esac
609
610 # If we are building a Canadian Cross, discard tools that can not be built
611 # using a cross compiler. FIXME: These tools should be fixed.
612 if [ "${build}" != "${host}" ]; then
613 noconfigdirs="$noconfigdirs tcl tk expect dejagnu"
614 fi
615
616 # Make sure we don't let GNU ld be added if we didn't want it.
617 if [ x$with_gnu_ld = xno ]; then
618 use_gnu_ld=no
619 noconfigdirs="$noconfigdirs ld"
620 fi
621
622 # Make sure we don't let GNU as be added if we didn't want it.
623 if [ x$with_gnu_as = xno ]; then
624 use_gnu_as=no
625 noconfigdirs="$noconfigdirs gas"
626 fi
627
628 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
629 # $target_configdirs.
630 # If we have the source for $noconfigdirs entries, add them to $notsupp.
631
632 notsupp=""
633 for dir in . $skipdirs $noconfigdirs ; do
634 dirname=`echo $dir | sed -e s/target-//g`
635 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
636 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
637 if [ -r $srcdir/$dirname/configure ] \
638 || [ -r $srcdir/$dirname/configure.in ]; then
639 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
640 true
641 else
642 notsupp="$notsupp $dir"
643 fi
644 fi
645 fi
646 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
647 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
648 if [ -r $srcdir/$dirname/configure ] \
649 || [ -r $srcdir/$dirname/configure.in ]; then
650 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
651 true
652 else
653 notsupp="$notsupp $dir"
654 fi
655 fi
656 fi
657 done
658
659 # Sometimes the tools are distributed with libiberty but with no other
660 # libraries. In that case, we don't want to build target-libiberty.
661 if [ -n "${target_configdirs}" ]; then
662 others=
663 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
664 if [ "$i" != "libiberty" ]; then
665 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
666 others=yes;
667 break;
668 fi
669 fi
670 done
671 if [ -z "${others}" ]; then
672 target_configdirs=
673 fi
674 fi
675
676 # Deconfigure all subdirectories, in case we are changing the
677 # configuration from one where a subdirectory is supported to one where it
678 # is not.
679 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
680 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
681 rm -f $i/Makefile
682 done
683 fi
684 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
685 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
686 rm -f ${target_subdir}/$i/Makefile
687 done
688 fi
689
690 # Produce a warning message for the subdirs we can't configure.
691 # This isn't especially interesting in the Cygnus tree, but in the individual
692 # FSF releases, it's important to let people know when their machine isn't
693 # supported by the one or two programs in a package.
694
695 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
696 # If $appdirs is non-empty, at least one of those directories must still
697 # be configured, or we error out. (E.g., if the gas release supports a
698 # specified target in some subdirs but not the gas subdir, we shouldn't
699 # pretend that all is well.)
700 if [ -n "$appdirs" ]; then
701 for dir in $appdirs ; do
702 if [ -r $dir/Makefile.in ]; then
703 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
704 appdirs=""
705 break
706 fi
707 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
708 appdirs=""
709 break
710 fi
711 fi
712 done
713 if [ -n "$appdirs" ]; then
714 echo "*** This configuration is not supported by this package." 1>&2
715 exit 1
716 fi
717 fi
718 # Okay, some application will build, or we don't care to check. Still
719 # notify of subdirs not getting built.
720 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
721 echo " ${notsupp}" 1>&2
722 echo " (Any other directories should still work fine.)" 1>&2
723 fi
724
725 # Set with_gnu_as and with_gnu_ld as appropriate.
726 #
727 # This is done by determining whether or not the appropriate directory
728 # is available, and by checking whether or not specific configurations
729 # have requested that this magic not happen.
730 #
731 # The command line options always override the explicit settings in
732 # configure.in, and the settings in configure.in override this magic.
733 #
734 # If the default for a toolchain is to use GNU as and ld, and you don't
735 # want to do that, then you should use the --without-gnu-as and
736 # --without-gnu-ld options for the configure script.
737
738 if [ x${use_gnu_as} = x ] ; then
739 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
740 with_gnu_as=yes
741 withoptions="$withoptions --with-gnu-as"
742 fi
743 fi
744
745 if [ x${use_gnu_ld} = x ] ; then
746 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
747 with_gnu_ld=yes
748 withoptions="$withoptions --with-gnu-ld"
749 fi
750 fi
751
752 # If using newlib, add --with-newlib to the withoptions so that gcc/configure
753 # can detect this case.
754
755 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
756 with_newlib=yes
757 withoptions="$withoptions --with-newlib"
758 fi
759
760 if [ x${shared} = xyes ]; then
761 case "${target}" in
762 hppa*) target_makefile_frag=config/mt-papic ;;
763 i[3456]86-*) target_makefile_frag=config/mt-x86pic ;;
764 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
765 esac
766 fi
767
768 # post-target:
769
770 # Make sure that the compiler is able to generate an executable. If it
771 # can't, we are probably in trouble. We don't care whether we can run the
772 # executable--we might be using a cross compiler--we only care whether it
773 # can be created. At this point the main configure script has set CC.
774 echo "int main () { return 0; }" > conftest.c
775 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
776 if [ $? = 0 ] && [ -s conftest ]; then
777 :
778 else
779 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
780 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
781 rm -f conftest*
782 exit 1
783 fi
784 rm -f conftest*
785
786 # The Solaris /usr/ucb/cc compiler does not appear to work.
787 case "${host}" in
788 sparc-sun-solaris2*)
789 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
790 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
791 could_use=
792 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
793 if [ -d /opt/cygnus/bin ] ; then
794 if [ "$could_use" = "" ] ; then
795 could_use="/opt/cygnus/bin"
796 else
797 could_use="$could_use or /opt/cygnus/bin"
798 fi
799 fi
800 if [ "$could_use" = "" ] ; then
801 echo "Warning: compilation may fail because you're using"
802 echo "/usr/ucb/cc. You should change your PATH or CC "
803 echo "variable and rerun configure."
804 else
805 echo "Warning: compilation may fail because you're using"
806 echo "/usr/ucb/cc, when you should use the C compiler from"
807 echo "$could_use. You should change your"
808 echo "PATH or CC variable and rerun configure."
809 fi
810 fi
811 ;;
812 esac
813
814 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
815 # binutils tools will find libbfd.so.
816 if [ "${shared}" = "yes" ]; then
817 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
818 Makefile > Makefile.tem
819 rm -f Makefile
820 mv -f Makefile.tem Makefile
821
822 case "${host}" in
823 *-*-hpux*)
824 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
825 Makefile > Makefile.tem
826 rm -f Makefile
827 mv -f Makefile.tem Makefile
828 ;;
829 esac
830 fi
831
832 # Record target_configdirs and the configure arguments in Makefile.
833 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
834 targargs=`echo "${arguments}" | \
835 sed -e 's/--norecursion//' \
836 -e 's/--cache[a-z-]*=[^ ]*//' \
837 -e 's/--ho[a-z-]*=[^ ]*//' \
838 -e 's/--ta[a-z-]*=[^ ]*//'`
839
840 # Passing a --with-cross-host argument lets the target libraries know
841 # whether they are being built with a cross-compiler or being built
842 # native. However, it would be better to use other mechanisms to make the
843 # sorts of decisions they want to make on this basis. Please consider
844 # this option to be deprecated. FIXME.
845 if [ x${is_cross_compiler} = xyes ]; then
846 targargs="--with-cross-host=${host_alias} ${targargs}"
847 fi
848
849 targargs="--host=${target_alias} ${targargs}"
850 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
851 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
852 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
853 Makefile > Makefile.tem
854 rm -f Makefile
855 mv -f Makefile.tem Makefile
856
857 #
858 # Local Variables:
859 # fill-column: 131
860 # End:
861 #
This page took 0.052108 seconds and 4 git commands to generate.